]> git.saurik.com Git - apt.git/blame - test/integration/framework
properly check for "all good sigs are weak"
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
5d76cee1 3EXIT_CODE=0
8c1dd12c 4
68042532
DK
5while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
61e92778
DK
12 elif [ "$1" = '--color=yes' ]; then
13 export MSGCOLOR='YES'
14 elif [ "$1" = '--color' ]; then
15 export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')"
16 shift
17 elif [ "$1" = '--level' ]; then
18 export MSGLEVEL=$2
19 shift
68042532
DK
20 else
21 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
22 fi
23 shift
24done
25export MSGLEVEL="${MSGLEVEL:-3}"
26
8d876415 27# we all like colorful messages
61e92778 28if [ "${MSGCOLOR:-YES}" = 'YES' ]; then
27cb4f6c 29 if [ ! -t 1 ]; then # but check that we output to a terminal
1290422a
DK
30 export MSGCOLOR='NO'
31 fi
32fi
33
34
35if [ "$MSGCOLOR" != 'NO' ]; then
36 CERROR="\033[1;31m" # red
37 CWARNING="\033[1;33m" # yellow
38 CMSG="\033[1;32m" # green
39 CINFO="\033[1;96m" # light blue
40 CDEBUG="\033[1;94m" # blue
41 CNORMAL="\033[0;39m" # default system console color
42 CDONE="\033[1;32m" # green
43 CPASS="\033[1;32m" # green
44 CFAIL="\033[1;31m" # red
45 CCMD="\033[1;35m" # pink
682a3bf7 46fi
8d876415 47
de81b2e2
DK
48msgprintf() {
49 local START="$1"
50 local MIDDLE="$2"
51 local END="$3"
52 shift 3
53 if [ -n "$1" ]; then
54 printf "$START " "$1"
d73840dc 55 shift
de81b2e2 56 while [ -n "$1" ]; do
bc8f83a5 57 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')"
de81b2e2
DK
58 shift
59 done
60 fi
61 printf "${END}"
2a2a7ef4 62}
de81b2e2
DK
63msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
64msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
65msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
66msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
67msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
68msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
69msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
70msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
71msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
72msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
73msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
3c528b91 74msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
1501a2c9 75msgreportheader() {
68042532 76 if [ -n "$MSGTEST_MSG" ]; then
1501a2c9 77 test "$1" != 'msgfailoutput' || echo
ae7fce5a
DK
78 if [ -n "$MSGTEST_MSGMSG" ]; then
79 echo "$MSGTEST_MSGMSG"
80 fi
22ac12b2 81 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
1501a2c9 82 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
22ac12b2 83 fi
68042532
DK
84 echo -n "$MSGTEST_MSG"
85 unset MSGTEST_MSG
86 fi
1501a2c9
DK
87}
88msgskip() {
89 msgreportheader 'msgskip'
68ba0b7f
DK
90 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
91 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
92}
5229b285 93msgfail() {
1501a2c9 94 msgreportheader 'msgfail'
68042532 95 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
3c528b91 96 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
03aa0847 97 if [ -n "$APT_DEBUG_TESTS" ]; then
896f0ae8 98 runapt $SHELL
03aa0847 99 fi
5229b285
DK
100 EXIT_CODE=$((EXIT_CODE+1));
101}
9beb11aa
DK
102MSGGROUP_LEVEL=0
103msggroup() {
104 if [ -n "$1" ]; then
105 if [ $MSGGROUP_LEVEL = 0 ]; then
106 MSGTEST_GRP='NEXT'
107 fi
108 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
109 else
110 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
111 if [ $MSGGROUP_LEVEL = 0 ]; then
112 unset MSGTEST_GRP
113 fi
114 fi
115}
8d876415
DK
116
117# enable / disable Debugging
fc89263e
DK
118if [ $MSGLEVEL -le 0 ]; then
119 msgdie() { true; }
120fi
121if [ $MSGLEVEL -le 1 ]; then
122 msgwarn() { true; }
123 msgnwarn() { true; }
124fi
125if [ $MSGLEVEL -le 2 ]; then
ae7fce5a
DK
126 msgmsg() {
127 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
128 }
fc89263e 129 msgnmsg() { true; }
9beb11aa
DK
130 msgtest() {
131 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
132 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
133 MSGTEST_GRP="$MSGTEST_MSG"
134 fi
135 }
3c528b91 136 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
fc89263e
DK
137fi
138if [ $MSGLEVEL -le 3 ]; then
139 msginfo() { true; }
140 msgninfo() { true; }
141fi
142if [ $MSGLEVEL -le 4 ]; then
143 msgdebug() { true; }
144 msgndebug() { true; }
145fi
146msgdone() {
147 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
148 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
149 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
150 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
151 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
152 true;
153 else
3c528b91 154 printf "${CDONE}DONE${CNORMAL}\n";
fc89263e
DK
155 fi
156}
e43a426e
MV
157getaptconfig() {
158 if [ -f ./aptconfig.conf ]; then
5465192b 159 echo "$(readlink -f ./aptconfig.conf)"
e43a426e 160 elif [ -f ../aptconfig.conf ]; then
5465192b
DK
161 echo "$(readlink -f ../aptconfig.conf)"
162 elif [ -f ../../aptconfig.conf ]; then
163 echo "$(readlink -f ../../aptconfig.conf)"
164 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
165 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
166 fi
e43a426e 167}
8d876415
DK
168runapt() {
169 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
846856f4
DK
170 local CMD="$1"
171 shift
3abb6a6a 172 case "$CMD" in
a311fb96 173 sh|aptitude|*/*|command) ;;
3b8eb3bc
DK
174 *) CMD="${BUILDDIRECTORY}/$CMD";;
175 esac
896f0ae8 176 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" "$CMD" "$@"
8d876415 177}
0390edd5 178runpython3() { runapt command python3 "$@"; }
846856f4
DK
179aptconfig() { runapt apt-config "$@"; }
180aptcache() { runapt apt-cache "$@"; }
181aptcdrom() { runapt apt-cdrom "$@"; }
182aptget() { runapt apt-get "$@"; }
183aptftparchive() { runapt apt-ftparchive "$@"; }
184aptkey() { runapt apt-key "$@"; }
185aptmark() { runapt apt-mark "$@"; }
4f6d26b4 186aptsortpkgs() { runapt apt-sortpkgs "$@"; }
796673c3 187apt() { runapt apt "$@"; }
3b8eb3bc
DK
188apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
189aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
190aptitude() { runapt aptitude "$@"; }
8d50b63f 191aptextracttemplates() { runapt apt-extracttemplates "$@"; }
3082603f 192aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
ad7e0941 193aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
3b8eb3bc 194
158fda31 195dpkg() {
b0be0e09 196 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
158fda31 197}
ce7f128c 198dpkgcheckbuilddeps() {
63c71412 199 command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@"
b6b5a542 200}
3fa950f1 201gdb() {
b07aeb1a
DK
202 local CMD
203 case "$1" in
204 aptget) CMD="apt-get";;
205 aptcache) CMD="apt-cache";;
5465192b
DK
206 aptcdrom) CMD="apt-cdrom";;
207 aptconfig) CMD="apt-config";;
b07aeb1a
DK
208 aptmark) CMD="apt-mark";;
209 apthelper) CMD="apt-helper";;
3d8232bf 210 aptftparchive) CMD="apt-ftparchive";;
63c71412 211 dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;;
b07aeb1a
DK
212 *) CMD="$1";;
213 esac
ce928105 214 shift
921a9626
DK
215 if [ "${CMD##*/}" = "$CMD" ]; then
216 CMD="${BUILDDIRECTORY}/${CMD}"
217 fi
218 runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@"
ae99ce2e 219}
8d876415 220
8c1dd12c 221exitwithstatus() {
f91bd741
MV
222 # error if we about to overflow, but ...
223 # "255 failures ought to be enough for everybody"
5d76cee1
MV
224 if [ $EXIT_CODE -gt 255 ]; then
225 msgdie "Total failure count $EXIT_CODE too big"
f91bd741 226 fi
5d76cee1 227 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
8c1dd12c
MV
228}
229
804d4a0d
DK
230shellsetedetector() {
231 local exit_status=$?
232 if [ "$exit_status" != '0' ]; then
3c528b91 233 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
804d4a0d
DK
234 if [ "$EXIT_CODE" = '0' ]; then
235 EXIT_CODE="$exit_status"
236 fi
237 fi
238}
239
b720d0bd 240addtrap() {
8437b7d4
DK
241 if [ "$1" = 'prefix' ]; then
242 CURRENTTRAP="$2 $CURRENTTRAP"
243 else
244 CURRENTTRAP="$CURRENTTRAP $1"
245 fi
804d4a0d 246 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 247}
8d876415 248
bc8f83a5
DK
249escape_shell() {
250 echo "$@" | sed -e "s#'#'\"'\"'#g"
251}
252
8d876415 253setupenvironment() {
0d303f17
DK
254 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
255 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
256 unset TMPDIR
257 fi
63c71412 258 TMPWORKINGDIRECTORY="$(mktemp -d)"
bc8f83a5
DK
259 addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';"
260 if [ -n "$TMPDIR_ADD" ]; then
261 TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}"
262 mkdir -p "$TMPWORKINGDIRECTORY"
263 unset TMPDIR_ADD
264 export TMPDIR="$TMPWORKINGDIRECTORY"
265 fi
63c71412 266 msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…"
5c0dd6fc 267
03aa0847 268 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
269 if [ "$(id -u)" = '0' ]; then
270 # relax permissions so that running as root with user switching works
271 umask 022
03aa0847
DK
272 chmod 711 "$TMPWORKINGDIRECTORY"
273 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
274 fi
275
63c71412 276 TESTDIRECTORY="$(readlink -f "$(dirname $0)")"
5c0dd6fc 277 # allow overriding the default BUILDDIR location
63c71412
DK
278 SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}"
279 BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}"
280 LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}"
281 METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}"
282 APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}"
283 APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}"
284 APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}"
285 APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}"
8d876415 286 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
5c0dd6fc
MV
287 # -----
288
63c71412 289 cd "$TMPWORKINGDIRECTORY"
cd725954 290 mkdir rootdir aptarchive keys
8d876415 291 cd rootdir
b29c3712 292 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
8fe964f1 293 mkdir -p usr/bin var/cache var/lib var/log tmp
cffea9af 294 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 295 touch var/lib/dpkg/available
8d876415 296 mkdir -p usr/lib/apt
63c71412 297 ln -s "${METHODSDIR}" usr/lib/apt/methods
1f6cf9e7
DK
298 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
299 mkdir -p usr/lib/apt/solvers
300 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
301 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
302 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
303 fi
291a386f
MV
304 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
305 # system
63c71412
DK
306 if [ -e "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" ]; then
307 ln -s "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove
291a386f
MV
308 else
309 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
310 fi
8d876415 311 cd ..
63c71412
DK
312 local BASENAME="${0##*/}"
313 local PACKAGESFILE="Packages-${BASENAME#*-}"
53ea1b56
DK
314 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
315 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 316 fi
63c71412 317 local SOURCESSFILE="Sources-${BASENAME#*-}"
53ea1b56
DK
318 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
319 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 320 fi
3abb6a6a
DK
321 find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \;
322 chmod 644 keys/*
63c71412 323 ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
d6cf2345 324
cffea9af 325 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 326 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415 327 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
9d2a8a73 328 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
23e64f6d
DK
329 # either store apt-key were we can access it, even if we run it as a different user
330 #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
331 #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
332 #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
333 # destroys coverage reporting though, so we disable changing user for the calling gpgv
334 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
68ba0b7f 335 if [ "$(id -u)" = '0' ]; then
23e64f6d 336 echo 'Binary::gpgv::Debug::NoDropPrivs "true";' >>aptconfig.conf
68ba0b7f 337 fi
b0be0e09 338
63c71412 339 cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
b0be0e09
DK
340#!/bin/sh
341set -e
3abb6a6a 342if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then
63c71412 343 if [ -n "\$LD_LIBRARY_PATH" ]; then
3abb6a6a 344 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}"
b0be0e09 345 else
3abb6a6a 346 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}'
b0be0e09 347 fi
921a9626 348 if [ -n "\$LD_PRELOAD" ]; then
63c71412 349 export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}"
921a9626 350 else
63c71412 351 export LD_PRELOAD="noopchroot.so"
921a9626
DK
352 fi
353fi
63c71412
DK
354EOF
355 cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
356 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
3abb6a6a
DK
357exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
358 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
63c71412
DK
359 --force-not-root --force-bad-path "\$@"
360EOF
361 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF
3abb6a6a
DK
362exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
363 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
b0be0e09
DK
364 --force-not-root --force-bad-path "\$@"
365EOF
921a9626 366 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
b0be0e09
DK
367 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
368
533fe3d1
DK
369 {
370 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
371 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
372 fi
87d6947d 373 echo 'quiet "0";'
533fe3d1
DK
374 echo 'quiet::NoUpdate "true";'
375 echo 'quiet::NoStatistic "true";'
376 # too distracting for users, but helpful to detect changes
377 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
378 echo 'Acquire::Progress::Diffpercent "true";'
379 # in testcases, it can appear as if localhost has a rotation setup,
380 # hide this as we can't really deal with it properly
381 echo 'Acquire::Failure::ShowIP "false";'
ebca2f25
DK
382 # fakeroot can't fake everything, so disabled in production but good for tests
383 echo 'APT::Sandbox::Verify "true";'
533fe3d1 384 } >> aptconfig.conf
d6cf2345 385
68ba0b7f
DK
386 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
387 if [ "$(id -u)" = '0' ]; then
388 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
389 fi
390 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
d6cf2345 391 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
23d35ec1 392 echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig
493a813e 393
276e51dd 394 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
51c04562 395 confighashes 'SHA256' # these are tests, not security best-practices
77a45beb 396
4bb006d1 397 # create some files in /tmp and look at user/group to get what this means
eab57e08 398 TEST_DEFAULT_USER="$(id -un)"
4bb006d1
DK
399 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
400 TEST_DEFAULT_GROUP='root'
401 else
eab57e08 402 TEST_DEFAULT_GROUP="$(id -gn)"
4bb006d1
DK
403 fi
404
ce7f128c 405 # cleanup the environment a bit
995a4bf6 406 # prefer our apt binaries over the system apt binaries
8c617819 407 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
be233796 408 export LC_ALL=C.UTF-8
3b8eb3bc 409 unset LANGUAGE APT_CONFIG
ce7f128c 410 unset GREP_OPTIONS DEB_BUILD_PROFILES
59f57473 411 unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy
0cbb7e29
JAK
412
413 # If gpgv supports --weak-digest, pass it to make sure we can disable SHA1
414 if aptkey verify --weak-digest SHA1 --help 2>/dev/null >/dev/null; then
415 echo 'Acquire::gpgv::Options { "--weak-digest"; "sha1"; };' > rootdir/etc/apt/apt.conf.d/no-sha1
416 fi
417
8d876415
DK
418 msgdone "info"
419}
420
ea65d079
DK
421getarchitecture() {
422 if [ "$1" = "native" -o -z "$1" ]; then
423 eval `aptconfig shell ARCH APT::Architecture`
424 if [ -n "$ARCH" ]; then
425 echo $ARCH
426 else
5834d7a1 427 dpkg --print-architecture
ea65d079
DK
428 fi
429 else
430 echo $1
431 fi
432}
433
53ea1b56 434getarchitectures() {
081c9d44 435 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
53ea1b56
DK
436}
437
3dcdc1f9
DK
438getarchitecturesfromcommalist() {
439 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
440}
441
8d876415 442configarchitecture() {
18908589
DK
443 {
444 echo "APT::Architecture \"$(getarchitecture $1)\";"
445 while [ -n "$1" ]; do
446 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
447 shift
448 done
449 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
53ea1b56
DK
450 configdpkg
451}
452
453configdpkg() {
454 if [ ! -e rootdir/var/lib/dpkg/status ]; then
63c71412
DK
455 local BASENAME="${0##*/}"
456 local STATUSFILE="status-${BASENAME#*-}"
53ea1b56
DK
457 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
458 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
459 else
460 echo -n > rootdir/var/lib/dpkg/status
461 fi
462 fi
18908589 463 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
846856f4 464 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
53ea1b56
DK
465 local ARCHS="$(getarchitectures)"
466 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
467 DPKGARCH="$(dpkg --print-architecture)"
468 for ARCH in ${ARCHS}; do
feae193b 469 if [ "${ARCH}" != "${DPKGARCH}" ]; then
18908589 470 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
feae193b 471 # old-style used e.g. in Ubuntu-P – and as it seems travis
18908589
DK
472 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
473 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
feae193b
DK
474 fi
475 fi
53ea1b56
DK
476 done
477 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
478 # dpkg doesn't really check the version as long as it is fully installed,
479 # but just to be sure we choose one above the required version
480 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
481 fi
482 fi
483 fi
8d876415
DK
484}
485
0c787570
DK
486configdpkgnoopchroot() {
487 # create a library to noop chroot() and rewrite maintainer script executions
488 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
489 # chroot directory dpkg could chroot into to execute the maintainer scripts
490 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
63c71412 491 cat > noopchroot.c << EOF
0c787570
DK
492#define _GNU_SOURCE
493#include <stdio.h>
494#include <stdlib.h>
495#include <string.h>
496#include <dlfcn.h>
497
498static char * chrootdir = NULL;
499
500int chroot(const char *path) {
501 printf("WARNING: CHROOTing to %s was ignored!\n", path);
502 free(chrootdir);
503 chrootdir = strdup(path);
504 return 0;
505}
506int execvp(const char *file, char *const argv[]) {
507 static int (*func_execvp) (const char *, char * const []) = NULL;
508 if (func_execvp == NULL)
509 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
510 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
511 return func_execvp(file, argv);
512 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
950733c9
JAK
513 char *newfile;
514 if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) {
515 perror("asprintf");
516 return -1;
517 }
b0be0e09 518 char const * const baseadmindir = "/var/lib/dpkg";
950733c9
JAK
519 char *admindir;
520 if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) {
521 perror("asprintf");
522 return -1;
523 }
b0be0e09 524 setenv("DPKG_ADMINDIR", admindir, 1);
0c787570
DK
525 return func_execvp(newfile, argv);
526}
527EOF
a66e1837 528 testempty --nomsg gcc -Wall -Wextra -fPIC -shared -o noopchroot.so noopchroot.c -ldl
0c787570 529}
276e51dd 530configcompression() {
abec2980 531 local CMD='apthelper cat-file -C'
276e51dd
DK
532 while [ -n "$1" ]; do
533 case "$1" in
3c528b91 534 '.') printf ".\t.\tcat\n";;
abec2980
DK
535 'gz') printf "gzip\tgz\t$CMD $1\n";;
536 'bz2') printf "bzip2\tbz2\t$CMD $1\n";;
537 *) printf "$1\t$1\t$CMD $1\n";;
276e51dd
DK
538 esac
539 shift
63c71412 540 done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
276e51dd 541}
c5ede4ca
DK
542confighashes() {
543 {
544 echo 'APT::FTPArchive {'
545 {
546 while [ -n "$1" ]; do
547 printf "$1" | tr 'a-z' 'A-Z'
548 printf "\t\"true\";\n"
549 shift
550 done
551 for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do
552 printf "$h\t\"false\";\n"
553 done
554 } | awk '!x[$1]++'
555 echo '};'
556 } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf"
557}
5f982b9d
DK
558forcecompressor() {
559 COMPRESSOR="$1"
912a6131 560 COMPRESS="$1"
abec2980 561 COMPRESSOR_CMD="apthelper cat-file -C $1"
5f982b9d
DK
562 case $COMPRESSOR in
563 gzip) COMPRESS='gz';;
564 bzip2) COMPRESS='bz2';;
5f982b9d
DK
565 esac
566 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
567 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
912a6131 568Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE"
5f982b9d
DK
569}
570
75954ae2 571setupsimplenativepackage() {
ce9864a8
DK
572 local NAME="$1"
573 local ARCH="$2"
574 local VERSION="$3"
575 local RELEASE="${4:-unstable}"
576 local DEPENDENCIES="$5"
14109555 577 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
578 If you find such a package installed on your system,
579 something went horribly wrong! They are autogenerated
3d284148 580 und used only by testcases and serve no other purpose…"}"
18908589 581
b7899b00
DK
582 local SECTION="${7:-others}"
583 local DISTSECTION
63c71412 584 if [ "$SECTION" = "${SECTION#*/}" ]; then
b7899b00
DK
585 DISTSECTION="main"
586 else
63c71412 587 DISTSECTION="${SECTION%/*}"
b7899b00 588 fi
ce9864a8
DK
589 local BUILDDIR=incoming/${NAME}-${VERSION}
590 mkdir -p ${BUILDDIR}/debian/source
591 cd ${BUILDDIR}
592 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
593 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
594 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
595
596 * Initial release
597
b7899b00
DK
598 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
599 test -e debian/control || echo "Source: $NAME
600Section: $SECTION
ce9864a8
DK
601Priority: optional
602Maintainer: Joe Sixpack <joe@example.org>
603Build-Depends: debhelper (>= 7)
604Standards-Version: 3.9.1
605
875bcb36
DK
606Package: $NAME" > debian/control
607 if [ "$ARCH" = 'all' ]; then
608 echo "Architecture: all" >> debian/control
609 else
610 echo "Architecture: any" >> debian/control
611 fi
ce9864a8 612 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
18908589
DK
613 echo "Description: $DESCRIPTION" >> debian/control
614
b7899b00
DK
615 test -e debian/compat || echo "7" > debian/compat
616 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 617 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
618 cd - > /dev/null
619}
620
621buildsimplenativepackage() {
622 local NAME="$1"
d56e2917
DK
623 local NM
624 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
625 NM="$(echo "$NAME" | cut -c 1-4)"
626 else
627 NM="$(echo "$NAME" | cut -c 1)"
628 fi
75954ae2
DK
629 local ARCH="$2"
630 local VERSION="$3"
631 local RELEASE="${4:-unstable}"
632 local DEPENDENCIES="$5"
14109555 633 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
634 If you find such a package installed on your system,
635 something went horribly wrong! They are autogenerated
3d284148 636 und used only by testcases and serve no other purpose…"}"
18908589 637
75954ae2 638 local SECTION="${7:-others}"
d67004e0 639 local PRIORITY="${8:-optional}"
63c71412
DK
640 local FILE_TREE="$9"
641 local COMPRESS_TYPE="${10:-gzip}"
75954ae2 642 local DISTSECTION
63c71412 643 if [ "$SECTION" = "${SECTION#*/}" ]; then
75954ae2
DK
644 DISTSECTION="main"
645 else
63c71412 646 DISTSECTION="${SECTION%/*}"
75954ae2 647 fi
63c71412 648 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
b761356f 649
0c787570 650 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
63c71412
DK
651 mkdir -p "$BUILDDIR/debian/source"
652 echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES"
b761356f 653 echo "#!/bin/sh
63c71412 654echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}"
b761356f 655
63c71412 656 echo "Copyleft by Joe Sixpack $(date +%Y)" > "${BUILDDIR}/debian/copyright"
b761356f
DK
657 echo "$NAME ($VERSION) $RELEASE; urgency=low
658
659 * Initial release
660
63c71412
DK
661 -- Joe Sixpack <joe@example.org> $(date -R)" > "${BUILDDIR}/debian/changelog"
662 {
663 echo "Source: $NAME
d67004e0 664Priority: $PRIORITY
b761356f 665Maintainer: Joe Sixpack <joe@example.org>
63c71412
DK
666Standards-Version: 3.9.3"
667 if [ "$SECTION" != '<none>' ]; then
668 echo "Section: $SECTION"
669 fi
670 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
671 test -z "$BUILDDEPS" || echo "$BUILDDEPS"
672 echo "
673Package: $NAME"
b761356f 674
63c71412
DK
675 if [ "$ARCH" = 'all' ]; then
676 echo "Architecture: all"
677 else
678 echo "Architecture: any"
679 fi
680 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
681 test -z "$DEPS" || echo "$DEPS"
682 echo "Description: $DESCRIPTION"
683 } > "${BUILDDIR}/debian/control"
01f520ce 684
63c71412
DK
685 echo '3.0 (native)' > "${BUILDDIR}/debian/source/format"
686 cd "${BUILDDIR}/.."
0c787570
DK
687 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
688 cd - >/dev/null
63c71412 689 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \
f1828b69 690 | while read SRC; do
63c71412 691 echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist"
f1828b69 692# if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
33a22672 693# aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
bd7fb5aa 694# adv --yes --default-key 'Joe Sixpack' \
f1828b69
DK
695# --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
696# mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
697# fi
b761356f 698 done
84aa13f4 699
3dcdc1f9 700 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
0c787570 701 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
63c71412
DK
702 rm -rf "${BUILDDIR}/debian/tmp"
703 mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin"
704 cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}"
705 cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}"
42c1513b 706 if [ -n "$FILE_TREE" ]; then
63c71412 707 cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp"
42c1513b 708 fi
42c1513b 709
63c71412
DK
710 (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch)
711 (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
846856f4 712 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
d56e2917 713 # ensure the right permissions as dpkg-deb insists
63c71412
DK
714 chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN"
715 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.."
716 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist"
84aa13f4
DK
717 done
718
d56e2917 719 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
63c71412
DK
720 mkdir -p "$CHANGEPATH"
721 cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH"
5a635ee4 722 rm -rf "${BUILDDIR}"
b761356f 723 msgdone "info"
75954ae2
DK
724}
725
726buildpackage() {
727 local BUILDDIR=$1
728 local RELEASE=$2
729 local SECTION=$3
ea65d079 730 local ARCH=$(getarchitecture $4)
846856f4
DK
731 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
732 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
0c787570 733 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
63c71412 734 cd "$BUILDDIR"
75954ae2
DK
735 if [ "$ARCH" = "all" ]; then
736 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
737 fi
0c787570 738 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
63c71412
DK
739 cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG"
740 local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")"
741 local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 742 cd - > /dev/null
b7899b00 743 for PKG in $PKGS; do
63c71412 744 echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist"
b7899b00
DK
745 done
746 for SRC in $SRCS; do
63c71412 747 echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist"
b7899b00 748 done
ce9864a8
DK
749}
750
751buildaptarchive() {
ce9864a8 752 if [ -d incoming ]; then
846856f4 753 buildaptarchivefromincoming "$@"
ce9864a8 754 else
846856f4 755 buildaptarchivefromfiles "$@"
ce9864a8
DK
756 fi
757}
758
759createaptftparchiveconfig() {
63c71412 760 local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')"
016bea82
DK
761 local COMPRESSORS="${COMPRESSORS%* }"
762 local ARCHS="$(getarchitectures)"
c5ede4ca
DK
763 cat > ftparchive.conf <<EOF
764Dir {
765 ArchiveDir "$(readlink -f .)";
766 CacheDir "$(readlink -f ..)";
767 FileListDir "$(readlink -f pool/)";
b7899b00
DK
768};
769Default {
c5ede4ca
DK
770 Packages::Compress "$COMPRESSORS";
771 Sources::Compress "$COMPRESSORS";
772 Contents::Compress "$COMPRESSORS";
773 Translation::Compress "$COMPRESSORS";
18331adf 774 LongDescription "false";
ce9864a8
DK
775};
776TreeDefault {
777 Directory "pool/";
778 SrcDirectory "pool/";
779};
c5ede4ca 780EOF
b7899b00 781 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
63c71412
DK
782 cat <<EOF
783tree "dists/$DIST" {
1dd20368 784 Architectures "$ARCHS all source";
63c71412
DK
785 FileList "${DIST}.\$(SECTION).pkglist";
786 SourceFileList "${DIST}.\$(SECTION).srclist";
787 Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')";
788};
789EOF
790 done >> ftparchive.conf
ce9864a8
DK
791}
792
793buildaptftparchivedirectorystructure() {
b7899b00
DK
794 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
795 for DIST in $DISTS; do
796 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
797 for SECTION in $SECTIONS; do
798 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
799 for ARCH in $ARCHS; do
63c71412 800 mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}"
b7899b00 801 done
63c71412
DK
802 mkdir -p "dists/${DIST}/${SECTION}/source"
803 mkdir -p "dists/${DIST}/${SECTION}/i18n"
b7899b00 804 done
ce9864a8 805 done
ce9864a8
DK
806}
807
9b78cda6 808insertpackage() {
10e100e5 809 local RELEASES="$1"
9b78cda6
DK
810 local NAME="$2"
811 local ARCH="$3"
812 local VERSION="$4"
813 local DEPENDENCIES="$5"
d67004e0 814 local PRIORITY="${6:-optional}"
10e100e5 815 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
18908589
DK
816 If you find such a package installed on your system,
817 something went horribly wrong! They are autogenerated
3d284148 818 und used only by testcases and serve no other purpose…"}"
d67004e0 819 local ARCHS=""
10e100e5
DK
820 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
821 if [ "$RELEASE" = 'installed' ]; then
822 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
823 continue
d67004e0 824 fi
10e100e5 825 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
1dd20368 826 if [ "$arch" = 'none' ]; then
10e100e5
DK
827 ARCHS="$(getarchitectures)"
828 else
829 ARCHS="$arch"
830 fi
831 for BUILDARCH in $ARCHS; do
832 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
63c71412
DK
833 mkdir -p "$PPATH"
834 {
835 echo "Package: $NAME
d67004e0 836Priority: $PRIORITY
9b78cda6 837Section: other
2c085486 838Installed-Size: 42
63c71412
DK
839Maintainer: Joe Sixpack <joe@example.org>"
840 test "$arch" = 'none' || echo "Architecture: $arch"
841 echo "Version: $VERSION
842Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb"
843 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES"
844 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)"
845 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)"
846 echo
847 } >> "${PPATH}/Packages"
10e100e5 848 done
d67004e0 849 done
63c71412
DK
850 mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n"
851 touch "aptarchive/dists/${RELEASE}/main/source/Sources"
10e100e5 852 echo "Package: $NAME
0e0d9919
DK
853Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
854Description-en: $DESCRIPTION
63c71412 855" >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en"
10e100e5 856 done
9b78cda6
DK
857}
858
234675b7 859insertsource() {
07aca07a 860 local RELEASES="$1"
234675b7
DK
861 local NAME="$2"
862 local ARCH="$3"
863 local VERSION="$4"
864 local DEPENDENCIES="$5"
07aca07a 865 local BINARY="${6:-$NAME}"
234675b7 866 local ARCHS=""
07aca07a
DK
867 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
868 local SPATH="aptarchive/dists/${RELEASE}/main/source"
869 mkdir -p $SPATH
870 local FILE="${SPATH}/Sources"
871 local DSCFILE="${NAME}_${VERSION}.dsc"
872 local TARFILE="${NAME}_${VERSION}.tar.gz"
873 echo "Package: $NAME
a8275acf 874Binary: $BINARY
234675b7
DK
875Version: $VERSION
876Maintainer: Joe Sixpack <joe@example.org>
877Architecture: $ARCH" >> $FILE
07aca07a
DK
878 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
879 echo "Files:
63c71412
DK
880 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
881 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
55ae7a51 882Checksums-Sha256:
63c71412
DK
883 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
884 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
885" >> "$FILE"
07aca07a 886 done
234675b7
DK
887}
888
dfc2b1be
DK
889insertinstalledpackage() {
890 local NAME="$1"
891 local ARCH="$2"
892 local VERSION="$3"
893 local DEPENDENCIES="$4"
d67004e0 894 local PRIORITY="${5:-optional}"
d4b4e5ea 895 local STATUS="${6:-install ok installed}"
14109555 896 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
18908589
DK
897 If you find such a package installed on your system,
898 something went horribly wrong! They are autogenerated
3d284148 899 und used only by testcases and serve no other purpose…"}"
18908589 900
53ea1b56
DK
901 local FILE='rootdir/var/lib/dpkg/status'
902 local INFO='rootdir/var/lib/dpkg/info'
3dcdc1f9 903 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
d67004e0 904 echo "Package: $NAME
d4b4e5ea 905Status: $STATUS
d67004e0 906Priority: $PRIORITY
dfc2b1be
DK
907Section: other
908Installed-Size: 42
909Maintainer: Joe Sixpack <joe@example.org>
63c71412
DK
910Version: $VERSION" >> "$FILE"
911 test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE"
912 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
913 echo "Description: $DESCRIPTION" >> "$FILE"
914 echo >> "$FILE"
53ea1b56 915 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
63c71412 916 echo -n > "${INFO}/${NAME}:${arch}.list"
53ea1b56 917 else
63c71412 918 echo -n > "${INFO}/${NAME}.list"
53ea1b56 919 fi
d67004e0 920 done
dfc2b1be
DK
921}
922
923
ce9864a8 924buildaptarchivefromincoming() {
63c71412 925 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…"
ce9864a8
DK
926 cd aptarchive
927 [ -e pool ] || ln -s ../incoming pool
928 [ -e ftparchive.conf ] || createaptftparchiveconfig
929 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 930 msgninfo "\tGenerate Packages, Sources and Contents files… "
31be38d2 931 testsuccess aptftparchive generate ftparchive.conf
ce9864a8
DK
932 cd - > /dev/null
933 msgdone "info"
4dbfe436 934 generatereleasefiles "$@"
ce9864a8
DK
935}
936
937buildaptarchivefromfiles() {
63c71412 938 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…"
8d041b4f
DK
939 local DIR='aptarchive'
940 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
941 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
9b78cda6 942 msgninfo "\t${line} file… "
276e51dd 943 compressfile "$line" "$1"
8d876415 944 msgdone "info"
9b78cda6 945 done
e3c62328 946 generatereleasefiles "$@"
9b78cda6
DK
947}
948
276e51dd 949compressfile() {
63c71412 950 cat "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | while read compressor extension command; do
276e51dd
DK
951 if [ "$compressor" = '.' ]; then
952 if [ -n "$2" ]; then
953 touch -d "$2" "$1"
954 fi
955 continue
956 fi
957 cat "$1" | $command > "${1}.${extension}"
958 if [ -n "$2" ]; then
959 touch -d "$2" "${1}.${extension}"
960 fi
961 done
962}
963
a3bbbab7 964# can be overridden by testcases for their pleasure
bf9e7447
DK
965getcodenamefromsuite() {
966 case "$1" in
967 unstable) echo 'sid';;
968 *) echo -n "$1";;
969 esac
970}
a3bbbab7 971getreleaseversionfromsuite() { true; }
718f797c 972getlabelfromsuite() { true; }
d56e2917 973getoriginfromsuite() { true; }
1dd20368 974getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; }
a3bbbab7 975
c5ede4ca
DK
976aptftparchiverelease() {
977 aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference
978}
9b78cda6 979generatereleasefiles() {
884a4c0a
DK
980 # $1 is the Date header and $2 is the ValidUntil header to be set
981 # both should be given in notation date/touch can understand
1dd20368
DK
982 local DATE="$1"
983 local VALIDUNTIL="$2"
9b78cda6 984 if [ -e aptarchive/dists ]; then
87d6947d 985 msgninfo "\tGenerate Release files for dists… "
9b78cda6 986 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
1dd20368 987 local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")"
a3bbbab7
DK
988 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
989 local CODENAME="$(getcodenamefromsuite $SUITE)"
990 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 991 local LABEL="$(getlabelfromsuite $SUITE)"
d56e2917 992 local ORIGIN="$(getoriginfromsuite $SUITE)"
63c71412 993 aptftparchiverelease "$dir" \
884a4c0a
DK
994 -o APT::FTPArchive::Release::Suite="${SUITE}" \
995 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
bc7a59dd
DK
996 -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \
997 -o APT::FTPArchive::Release::Label="${LABEL}" \
998 -o APT::FTPArchive::Release::Origin="${ORIGIN}" \
999 -o APT::FTPArchive::Release::Version="${VERSION}" \
63c71412 1000 > "$dir/Release"
a3bbbab7 1001 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11 1002 sed -i '/^Date: / a\
63c71412 1003NotAutomatic: yes' "$dir/Release"
35faae11 1004 fi
9b78cda6
DK
1005 done
1006 else
87d6947d 1007 msgninfo "\tGenerate Release files for flat… "
c5ede4ca 1008 aptftparchiverelease ./aptarchive > aptarchive/Release
8d876415 1009 fi
1dd20368 1010 if [ -n "$DATE" -a "$DATE" != "now" ]; then
fe0f7911 1011 for release in $(find ./aptarchive -name 'Release'); do
1dd20368
DK
1012 sed -i "s/^Date: .*$/Date: $(date -d "$DATE" '+%a, %d %b %Y %H:%M:%S %Z')/" "$release"
1013 touch -d "$DATE" "$release"
fe0f7911 1014 done
8d876415 1015 fi
1dd20368 1016 if [ -n "$VALIDUNTIL" ]; then
c5ede4ca 1017 sed -i "/^Date: / a\
1dd20368 1018Valid-Until: $(date -d "$VALIDUNTIL" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release')
c5ede4ca 1019 fi
b7899b00 1020 msgdone "info"
8d876415
DK
1021}
1022
b7899b00 1023setupdistsaptarchive() {
63c71412 1024 local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')"
b7899b00
DK
1025 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1026 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1027 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
63c71412 1028 SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
b7899b00 1029 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
63c71412
DK
1030 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list"
1031 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list"
b7899b00
DK
1032 msgdone "info"
1033 done
1034}
1035
1036setupflataptarchive() {
63c71412
DK
1037 local APTARCHIVE="$(readlink -f ./aptarchive)"
1038 local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1039 if [ -f "${APTARCHIVE}/Packages" ]; then
8d876415 1040 msgninfo "\tadd deb sources.list line… "
63c71412
DK
1041 echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1042 msgdone 'info'
8d876415 1043 else
63c71412 1044 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
8d876415 1045 fi
63c71412 1046 if [ -f "${APTARCHIVE}/Sources" ]; then
8d876415 1047 msgninfo "\tadd deb-src sources.list line… "
63c71412
DK
1048 echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1049 msgdone 'info'
8d876415 1050 else
63c71412 1051 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
8d876415 1052 fi
b7899b00
DK
1053}
1054
1055setupaptarchive() {
4dbfe436
DK
1056 local NOUPDATE=0
1057 if [ "$1" = '--no-update' ]; then
1058 NOUPDATE=1
1059 shift
1060 fi
1061 buildaptarchive "$@"
b7899b00
DK
1062 if [ -e aptarchive/dists ]; then
1063 setupdistsaptarchive
1064 else
1065 setupflataptarchive
1066 fi
9d653a6d 1067 signreleasefiles 'Joe Sixpack'
4dbfe436 1068 if [ "1" != "$NOUPDATE" ]; then
5684f71f 1069 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
b2ea1a47 1070 fi
8d876415
DK
1071}
1072
f213b6ea
DK
1073signreleasefiles() {
1074 local SIGNER="${1:-Joe Sixpack}"
07cb47e7 1075 local REPODIR="${2:-aptarchive}"
f1e1abd8 1076 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
8fa99570 1077 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes --digest-algo ${APT_TESTS_DIGEST_ALGO:-SHA512}"
f1e1abd8 1078 msgninfo "\tSign archive with $SIGNER key $KEY… "
29a59c46
DK
1079 local REXKEY='keys/rexexpired'
1080 local SECEXPIREBAK="${REXKEY}.sec.bak"
1081 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1082 if [ "${SIGNER}" = 'Rex Expired' ]; then
1083 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1084 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1085 # therefore we 'temporary' make the key not expired and restore a backup after signing
63c71412
DK
1086 cp "${REXKEY}.sec" "$SECEXPIREBAK"
1087 cp "${REXKEY}.pub" "$PUBEXPIREBAK"
29a59c46
DK
1088 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1089 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1090 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
63c71412
DK
1091 cp "$SECUNEXPIRED" "${REXKEY}.sec"
1092 cp "$PUBUNEXPIRED" "${REXKEY}.pub"
29a59c46 1093 else
f1e1abd8
DK
1094 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1095 cat setexpire.gpg
1096 exit 1
1097 fi
63c71412
DK
1098 cp "${REXKEY}.sec" "$SECUNEXPIRED"
1099 cp "${REXKEY}.pub" "$PUBUNEXPIRED"
29a59c46
DK
1100 fi
1101 fi
63c71412 1102 for RELEASE in $(find "${REPODIR}/" -name Release); do
785cb6fc 1103 testsuccess $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}"
e3c62328 1104 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
785cb6fc 1105 testsuccess $GPG --default-key "$SIGNER" --clearsign --output "$INRELEASE" "$RELEASE"
e3c62328 1106 # we might have set a specific date for the Release file, so copy it
63c71412 1107 touch -d "$(stat --format "%y" ${RELEASE})" "${RELEASE}.gpg" "${INRELEASE}"
f213b6ea 1108 done
29a59c46 1109 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
63c71412
DK
1110 mv -f "$SECEXPIREBAK" "${REXKEY}.sec"
1111 mv -f "$PUBEXPIREBAK" "${REXKEY}.pub"
29a59c46 1112 fi
63c71412 1113 msgdone 'info'
f213b6ea
DK
1114}
1115
8eafc759
DK
1116redatereleasefiles() {
1117 local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1118 for release in $(find aptarchive/ -name 'Release'); do
63c71412
DK
1119 sed -i "s/^Date: .*$/Date: ${DATE}/" "$release"
1120 touch -d "$DATE" "$release"
8eafc759
DK
1121 done
1122 signreleasefiles "${2:-Joe Sixpack}"
1123}
1124
f2c0ec8b 1125webserverconfig() {
6c0765c0 1126 local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}"
b0314abb
DK
1127 local NOCHECK=false
1128 if [ "$1" = '--no-check' ]; then
1129 NOCHECK=true
1130 shift
1131 fi
0d58c26a 1132 local DOWNLOG='rootdir/tmp/download-testfile.log'
b0314abb 1133 local STATUS='downloaded/webserverconfig.status'
0d58c26a 1134 rm -f "$STATUS" "$DOWNLOG"
6c0765c0 1135 # very very basic URI encoding
b0314abb
DK
1136 local URI
1137 if [ -n "$2" ]; then
1138 msgtest "Set webserver config option '${1}' to" "$2"
6c0765c0 1139 URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')"
b0314abb
DK
1140 else
1141 msgtest 'Clear webserver config option' "${1}"
6c0765c0 1142 URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')"
b0314abb
DK
1143 fi
1144 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
f2c0ec8b
DK
1145 msgpass
1146 else
68042532
DK
1147 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1148 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1149 msgfailoutput '' "$OUTPUT"
f2c0ec8b 1150 fi
b0314abb 1151 $NOCHECK || testwebserverlaststatuscode '200'
f2c0ec8b
DK
1152}
1153
fd46d305 1154rewritesourceslist() {
63c71412 1155 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
af9e40c9 1156 local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
fd46d305 1157 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
af9e40c9 1158 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \
28b2efcb
DK
1159 -e "s#http://[^@]*@\?localhost:${APTHTTPPORT}/\?#${1}#" \
1160 -e "s#https://[^@]*@\?localhost:${APTHTTPSPORT}/\?#${1}#"
fd46d305
DK
1161 done
1162}
1163
5572f6bd
MV
1164# wait for up to 10s for a pid file to appear to avoid possible race
1165# when a helper is started and dosn't write the PID quick enough
1166waitforpidfile() {
1167 local PIDFILE="$1"
1168 for i in $(seq 10); do
1169 if test -s "$PIDFILE"; then
1170 return 0
1171 fi
1172 sleep 1
1173 done
1174 msgdie "waiting for $PIDFILE failed"
1175 return 1
1176}
1177
f213b6ea 1178changetowebserver() {
6c0765c0 1179 local REWRITE='no'
23af9f40 1180 if [ "$1" != '--no-rewrite' ]; then
6c0765c0 1181 REWRITE='yes'
23af9f40
DK
1182 else
1183 shift
1184 fi
63c71412 1185 if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then
fbd29dd6 1186 cd aptarchive
a0db467c 1187 local LOG="webserver.log"
6c0765c0 1188 if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then
3abb6a6a 1189 cat "$LOG"
bee0670b
DK
1190 false
1191 fi
6c0765c0 1192 waitforpidfile aptwebserver.pid
e3c62328
DK
1193 local PID="$(cat aptwebserver.pid)"
1194 if [ -z "$PID" ]; then
1195 msgdie 'Could not fork aptwebserver successfully'
1196 fi
1197 addtrap "kill $PID;"
6c0765c0
DK
1198 waitforpidfile aptwebserver.port
1199 APTHTTPPORT="$(cat aptwebserver.port)"
1200 if [ -z "$APTHTTPPORT" ]; then
1201 msgdie 'Could not get port for aptwebserver successfully'
1202 fi
fbd29dd6 1203 cd - > /dev/null
c5bcc607 1204 else
3d284148 1205 msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver'
f213b6ea 1206 fi
6c0765c0
DK
1207 if [ "$REWRTE" != 'yes' ]; then
1208 rewritesourceslist "http://localhost:${APTHTTPPORT}/"
1209 fi
fd46d305
DK
1210}
1211
1212changetohttpswebserver() {
e75e5879 1213 if ! command -v stunnel4 >/dev/null 2>&1; then
fd46d305
DK
1214 msgdie 'You need to install stunnel4 for https testcases'
1215 fi
1216 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
dc95fee1 1217 changetowebserver --no-rewrite "$@"
fd46d305
DK
1218 fi
1219 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
68ba0b7f 1220cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
23af9f40 1221output = /dev/null
fd46d305
DK
1222
1223[https]
6c0765c0
DK
1224accept = 0
1225connect = $APTHTTPPORT
63c71412 1226" > "${TMPWORKINGDIRECTORY}/stunnel.conf"
fd46d305 1227 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
5572f6bd 1228 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
63c71412 1229 local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")"
5572f6bd
MV
1230 if [ -z "$PID" ]; then
1231 msgdie 'Could not fork stunnel4 successfully'
1232 fi
fd46d305 1233 addtrap 'prefix' "kill ${PID};"
6970f6e6 1234 APTHTTPSPORT="$(lsof -i -n | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)"
6c0765c0
DK
1235 webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}"
1236 rewritesourceslist "https://localhost:${APTHTTPSPORT}/"
f213b6ea
DK
1237}
1238
c45233ea
DK
1239changetocdrom() {
1240 mkdir -p rootdir/media/cdrom/.disk
1241 local CD="$(readlink -f rootdir/media/cdrom)"
63c71412
DK
1242 cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF
1243acquire::cdrom::mount "${CD}";
1244acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}";
1245acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted";
1246acquire::cdrom::autodetect 0;
1247EOF
1248 echo -n "$1" > "${CD}/.disk/info"
c45233ea
DK
1249 if [ ! -d aptarchive/dists ]; then
1250 msgdie 'Flat file archive cdroms can not be created currently'
1251 return 1
1252 fi
a0975c8d 1253 mv aptarchive/dists "$CD"
63c71412 1254 ln -s "$(readlink -f ./incoming)" "$CD/pool"
c45233ea 1255 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
a0975c8d
DK
1256 # start with an unmounted disk
1257 mv "${CD}" "${CD}-unmounted"
1258 # we don't want the disk to be modifiable
bc8f83a5 1259 addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;"
b0314abb 1260 chmod -R 555 rootdir/media/cdrom-unmounted/dists
c45233ea
DK
1261}
1262
fd46d305 1263downloadfile() {
ed793a19 1264 local PROTO="${1%%:*}"
27925d82 1265 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
dcbb364f 1266 download-file "$1" "$2" "$3" 2>&1 ; then
27925d82
DK
1267 return 1
1268 fi
fd46d305 1269 # only if the file exists the download was successful
b0314abb 1270 if [ -r "$2" ]; then
fd46d305
DK
1271 return 0
1272 else
1273 return 1
1274 fi
1275}
1276
f213b6ea 1277checkdiff() {
03aa0847 1278 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
8d876415 1279 if [ -n "$DIFFTEXT" ]; then
0d58c26a
DK
1280 echo >&2
1281 echo >&2 "$DIFFTEXT"
8d876415
DK
1282 return 1
1283 else
1284 return 0
1285 fi
1286}
1287
22ac12b2
DK
1288testoutputequal() {
1289 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1290 local COMPAREFILE="$1"
1291 shift
63c71412 1292 if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
22ac12b2
DK
1293 msgpass
1294 else
1295 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1296 cat "$COMPAREFILE" >>"${OUTPUT}"
1297 msgfailoutput '' "$OUTPUT" "$@"
1298 fi
1299}
1300
75954ae2 1301testfileequal() {
1501a2c9 1302 msggroup 'testfileequal'
e6a12ff7
DK
1303 local MSG='Test for correctness of file'
1304 if [ "$1" = '--nomsg' ]; then
1305 MSG=''
1306 shift
1307 fi
75954ae2
DK
1308 local FILE="$1"
1309 shift
e6a12ff7
DK
1310 if [ -n "$MSG" ]; then
1311 msgtest "$MSG" "$FILE"
1312 fi
68042532 1313 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
75954ae2 1314 if [ -z "$*" ]; then
22ac12b2 1315 testoutputequal "$FILE" echo -n ''
75954ae2 1316 else
22ac12b2 1317 testoutputequal "$FILE" echo "$*"
75954ae2 1318 fi
9beb11aa 1319 msggroup
75954ae2
DK
1320}
1321
b855a400 1322testempty() {
1501a2c9 1323 msggroup 'testempty'
a66e1837
DK
1324 if [ "$1" = '--nomsg' ]; then
1325 shift
1326 else
1327 msgtest "Test for no output of" "$*"
1328 fi
859093da 1329 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
a66e1837 1330 if "$@" >"$COMPAREFILE" 2>&1 && test ! -s "$COMPAREFILE"; then
859093da
DK
1331 msgpass
1332 else
22ac12b2 1333 msgfailoutput '' "$COMPAREFILE" "$@"
859093da 1334 fi
ab25bf1f 1335 aptautotest 'testempty' "$@"
9beb11aa 1336 msggroup
b855a400 1337}
63c71412
DK
1338testnotempty() {
1339 msggroup 'testnotempty'
1340 msgtest "Test for some output of" "$*"
1341 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile"
1342 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then
1343 msgpass
1344 else
1345 msgfailoutput '' "$COMPAREFILE" "$@"
1346 fi
1347 aptautotest 'testnotempty' "$@"
1348 msggroup
1349}
b855a400 1350
f74a6fa1 1351testequal() {
1501a2c9 1352 msggroup 'testequal'
f74a6fa1
DK
1353 local MSG='Test of equality of'
1354 if [ "$1" = '--nomsg' ]; then
1355 MSG=''
1356 shift
1357 fi
1358
03938280 1359 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
63c71412 1360 echo "$1" > "$COMPAREFILE"
8d876415 1361 shift
d2d68aaf 1362
f74a6fa1
DK
1363 if [ -n "$MSG" ]; then
1364 msgtest "$MSG" "$*"
1365 fi
22ac12b2 1366 testoutputequal "$COMPAREFILE" "$@"
ab25bf1f 1367 aptautotest 'testequal' "$@"
9beb11aa 1368 msggroup
8d876415
DK
1369}
1370
685625bd 1371testequalor2() {
1501a2c9 1372 msggroup 'testequalor2'
03938280
DK
1373 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1374 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1375 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
63c71412
DK
1376 echo "$1" > "$COMPAREFILE1"
1377 echo "$2" > "$COMPAREFILE2"
685625bd
DK
1378 shift 2
1379 msgtest "Test for equality OR of" "$*"
63c71412
DK
1380 "$@" >"$COMPAREAGAINST" 2>&1 || true
1381 if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \
1382 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1
0d58c26a 1383 then
0caa5a4c
DK
1384 msgpass
1385 else
68042532
DK
1386 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1387 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1388 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1389 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1390 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1391 msgfailoutput '' "$OUTPUT"
0caa5a4c 1392 fi
ab25bf1f 1393 aptautotest 'testequalor2' "$@"
9beb11aa 1394 msggroup
685625bd
DK
1395}
1396
8d876415 1397testshowvirtual() {
1501a2c9 1398 msggroup 'testshowvirtual'
edc0ef10 1399 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1400 local PACKAGE="$1"
1401 shift
1402 while [ -n "$1" ]; do
1403 VIRTUAL="${VIRTUAL}
edc0ef10 1404N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1405 PACKAGE="${PACKAGE} $1"
1406 shift
1407 done
1408 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1409 VIRTUAL="${VIRTUAL}
4bec02c2 1410N: No packages found"
03938280 1411 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
ea65d079 1412 local ARCH="$(getarchitecture 'native')"
68042532
DK
1413 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1414 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
87d6947d 1415 testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE"
9beb11aa 1416 msggroup
8d876415
DK
1417}
1418
1419testnopackage() {
1501a2c9 1420 msggroup 'testnopackage'
8d876415 1421 msgtest "Test for non-existent packages" "apt-cache show $*"
846856f4 1422 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
8d876415 1423 if [ -n "$SHOWPKG" ]; then
68042532
DK
1424 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1425 echo "$SHOWPKG" >"$OUTPUT"
1426 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1427 else
1428 msgpass
8d876415 1429 fi
9beb11aa 1430 msggroup
8d876415 1431}
bd4a8f51
DK
1432testnosrcpackage() {
1433 msggroup 'testnosrcpackage'
1434 msgtest "Test for non-existent source packages" "apt-cache showsrc $*"
1435 local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')"
1436 if [ -n "$SHOWPKG" ]; then
1437 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output"
1438 echo "$SHOWPKG" >"$OUTPUT"
1439 msgfailoutput '' "$OUTPUT"
1440 else
1441 msgpass
1442 fi
1443 msggroup
1444}
01a6e24c 1445
ecb777dd 1446testdpkgstatus() {
1501a2c9 1447 msggroup 'testdpkgstatus'
ecb777dd
DK
1448 local STATE="$1"
1449 local NR="$2"
1450 shift 2
1451 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1452 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1453 if [ "$PKGS" != $NR ]; then
68042532
DK
1454 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1455 echo "$PKGS" >"$OUTPUT"
1456 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1457 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1458 else
1459 msgpass
01a6e24c 1460 fi
9beb11aa 1461 msggroup
01a6e24c
DK
1462}
1463
ecb777dd 1464testdpkginstalled() {
1501a2c9 1465 msggroup 'testdpkginstalled'
ecb777dd 1466 testdpkgstatus 'ii' "$#" "$@"
9beb11aa 1467 msggroup
ecb777dd
DK
1468}
1469
5cf733e1 1470testdpkgnotinstalled() {
1501a2c9 1471 msggroup 'testdpkgnotinstalled'
ecb777dd 1472 testdpkgstatus 'ii' '0' "$@"
9beb11aa 1473 msggroup
01a6e24c 1474}
ec7f904e
DK
1475
1476testmarkedauto() {
1501a2c9 1477 msggroup 'testmarkedauto'
03938280 1478 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
ec7f904e
DK
1479 if [ -n "$1" ]; then
1480 msgtest 'Test for correctly marked as auto-installed' "$*"
63c71412 1481 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
ec7f904e
DK
1482 else
1483 msgtest 'Test for correctly marked as auto-installed' 'no package'
63c71412 1484 echo -n > "$COMPAREFILE"
ec7f904e 1485 fi
22ac12b2 1486 testoutputequal "$COMPAREFILE" aptmark showauto
9beb11aa 1487 msggroup
ec7f904e 1488}
7c2cc4a7 1489testmarkedmanual() {
1501a2c9 1490 msggroup 'testmarkedmanual'
7c2cc4a7
DK
1491 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1492 if [ -n "$1" ]; then
1493 msgtest 'Test for correctly marked as manually installed' "$*"
63c71412 1494 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
7c2cc4a7
DK
1495 else
1496 msgtest 'Test for correctly marked as manually installed' 'no package'
63c71412 1497 echo -n > "$COMPAREFILE"
7c2cc4a7 1498 fi
22ac12b2 1499 testoutputequal "$COMPAREFILE" aptmark showmanual
9beb11aa 1500 msggroup
7c2cc4a7 1501}
89a1aa5d 1502
e52aad52 1503msgfailoutput() {
1501a2c9 1504 msgreportheader 'msgfailoutput'
e52aad52
DK
1505 local MSG="$1"
1506 local OUTPUT="$2"
1507 shift 2
e52aad52 1508 if [ "$1" = 'grep' ]; then
68042532 1509 echo >&2
e52aad52
DK
1510 while [ -n "$2" ]; do shift; done
1511 echo "#### Complete file: $1 ####"
1512 cat >&2 "$1" || true
1513 echo '#### grep output ####'
1514 elif [ "$1" = 'test' ]; then
68042532 1515 echo >&2
e52aad52
DK
1516 # doesn't support ! or non-file flags
1517 msgfailoutputstatfile() {
1518 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1519 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1520 echo "#### stat(2) of file: $2 ####"
1521 stat "$2" || true
dffc17ba
DK
1522 if test -d "$2"; then
1523 echo "#### The directory contains: $2 ####"
1524 ls >&2 "$2" || true
1525 elif test -e "$2"; then
3196dae8
DK
1526 echo "#### Complete file: $2 ####"
1527 cat >&2 "$2" || true
1528 fi
e52aad52
DK
1529 fi
1530 }
1531 msgfailoutputstatfile "$2" "$3"
1532 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1533 shift 3
1534 msgfailoutputstatfile "$2" "$3"
1535 done
1536 echo '#### test output ####'
6fc2e030
DK
1537 elif [ "$1" = 'cmp' ]; then
1538 echo >&2
1539 while [ -n "$2" ]; do
1540 echo "#### Complete file: $2 ####"
1541 cat >&2 "$2" || true
1542 shift
1543 done
1544 echo '#### cmp output ####'
e52aad52 1545 fi
63c71412 1546 cat >&2 "$OUTPUT"
e52aad52
DK
1547 msgfail "$MSG"
1548}
1549
671a55ba
DK
1550testsuccesswithglobalerror() {
1551 local TYPE="$1"
1552 local ERRORS="$2"
1553 shift 2
1554 msggroup "$TYPE"
0440d936
DK
1555 if [ "$1" = '--nomsg' ]; then
1556 shift
1557 else
1558 msgtest 'Test for successful execution of' "$*"
1559 fi
671a55ba 1560 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output"
63c71412 1561 if "$@" >"${OUTPUT}" 2>&1; then
4fa34122 1562 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1563 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1564 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
671a55ba 1565 elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
3261271e
DK
1566 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1567 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1568 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1569 msgpass
1570 else
1571 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1572 fi
1573 else
1574 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1575 fi
671a55ba
DK
1576 elif [ "$TYPE" = 'testsuccesswithnotice' ]; then
1577 if grep -q -E "^N: " "$OUTPUT"; then
1578 msgpass
1579 else
1580 msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@"
1581 fi
4fa34122
DK
1582 else
1583 msgpass
1584 fi
1585 else
1586 msgpass
1587 fi
1588 else
1589 local EXITCODE=$?
e52aad52 1590 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
4fa34122 1591 fi
671a55ba 1592 aptautotest "$TYPE" "$@"
9beb11aa 1593 msggroup
4fa34122 1594}
671a55ba
DK
1595testsuccesswithnotice() {
1596 testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@"
1597}
1598testsuccess() {
1599 testsuccesswithglobalerror 'testsuccess' 'NWE' "$@"
1600}
4fa34122 1601testwarning() {
1501a2c9 1602 msggroup 'testwarning'
4fa34122
DK
1603 if [ "$1" = '--nomsg' ]; then
1604 shift
1605 else
1606 msgtest 'Test for successful execution with warnings of' "$*"
1607 fi
25b86db1 1608 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
63c71412 1609 if "$@" >"${OUTPUT}" 2>&1; then
1df24acf 1610 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1611 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1612 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1613 elif grep -q -E '^E: ' "$OUTPUT"; then
1614 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
4fa34122 1615 elif ! grep -q -E '^W: ' "$OUTPUT"; then
e52aad52 1616 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1df24acf
DK
1617 else
1618 msgpass
1619 fi
1620 else
1621 msgpass
1622 fi
0440d936 1623 else
07cb47e7 1624 local EXITCODE=$?
68042532 1625 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1626 fi
4fa34122 1627 aptautotest 'testwarning' "$@"
9beb11aa 1628 msggroup
0440d936 1629}
0440d936 1630testfailure() {
1501a2c9 1631 msggroup 'testfailure'
0440d936
DK
1632 if [ "$1" = '--nomsg' ]; then
1633 shift
1634 else
889b0072 1635 msgtest 'Test for failure in execution of' "$*"
0440d936 1636 fi
03938280 1637 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
63c71412 1638 if "$@" >"${OUTPUT}" 2>&1; then
07cb47e7 1639 local EXITCODE=$?
e52aad52 1640 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1641 else
1df24acf
DK
1642 local EXITCODE=$?
1643 if expr match "$1" '^apt.*' >/dev/null; then
b0d40854
DK
1644 if [ "$1" = 'aptkey' ]; then
1645 if grep -q -E " Can't check signature: " "$OUTPUT" || \
1646 grep -q -E " BAD signature from " "$OUTPUT"; then
1647 msgpass
1648 else
1649 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1650 fi
1df24acf 1651 else
b0d40854
DK
1652 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1653 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1654 elif grep -q -E '==ERROR' "$OUTPUT"; then
1655 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1656 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1657 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1658 else
1659 msgpass
1660 fi
1df24acf
DK
1661 fi
1662 else
1663 msgpass
1664 fi
0440d936 1665 fi
ab25bf1f 1666 aptautotest 'testfailure' "$@"
9beb11aa 1667 msggroup
0440d936
DK
1668}
1669
7414af7f
DK
1670testreturnstateequal() {
1671 local STATE="$1"
671a55ba
DK
1672 if [ "$STATE" = 'testsuccesswithglobalerror' ]; then
1673 local STATE="$2"
1674 local TYPE="$3"
7414af7f 1675 shift 3
671a55ba
DK
1676 msggroup "${STATE}equal"
1677 if [ "$1" != '--nomsg' ]; then
1678 local CMP="$1"
1679 shift
1680 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1681 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1682 else
1683 local CMP="$2"
1684 shift 2
1685 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1686 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1687 fi
1688 else
1689 msggroup "${STATE}equal"
1690 if [ "$2" != '--nomsg' ]; then
1691 local CMP="$2"
1692 shift 2
1693 "$STATE" "$@"
1694 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1695 else
1696 local CMP="$3"
1697 shift 3
1698 "$STATE" --nomsg "$@"
1699 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1700 fi
7414af7f 1701 fi
9beb11aa 1702 msggroup
25b86db1 1703}
7414af7f 1704testsuccessequal() {
671a55ba
DK
1705 # we compare output, so we know perfectly well about N:
1706 testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@"
7414af7f 1707}
25b86db1 1708testwarningequal() {
7414af7f 1709 testreturnstateequal 'testwarning' "$@"
25b86db1
DK
1710}
1711testfailureequal() {
7414af7f 1712 testreturnstateequal 'testfailure' "$@"
25b86db1
DK
1713}
1714
27925d82 1715testfailuremsg() {
1501a2c9 1716 msggroup 'testfailuremsg'
27925d82
DK
1717 local CMP="$1"
1718 shift
1719 testfailure "$@"
1720 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
68042532 1721 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
002b1bc4 1722 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
22ac12b2 1723 testoutputequal "$COMPAREFILE" echo "$CMP"
9beb11aa 1724 msggroup
27925d82 1725}
f18f2338
DK
1726testwarningmsg() {
1727 msggroup 'testwarningmsg'
1728 local CMP="$1"
1729 shift
1730 testwarning "$@"
1731 msgtest 'Check that the output of the previous warned command has expected' 'warnings'
1732 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile"
002b1bc4 1733 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true
f18f2338
DK
1734 testoutputequal "$COMPAREFILE" echo "$CMP"
1735 msggroup
1736}
25b86db1 1737
de81b2e2 1738testfilestats() {
1501a2c9 1739 msggroup 'testfilestats'
de81b2e2
DK
1740 msgtest "Test that file $1 has $2 $3" "$4"
1741 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
5684f71f
DK
1742 msgpass
1743 else
68042532
DK
1744 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1745 {
1746 ls -ld "$1" || true
1747 echo -n "stat(1) reports for $2: "
1748 stat --format "$2" "$1" || true
1749 } >"$OUTPUT" 2>&1
1750 msgfailoutput '' "$OUTPUT"
5684f71f 1751 fi
9beb11aa 1752 msggroup
5684f71f 1753}
de81b2e2 1754testaccessrights() {
1501a2c9 1755 msggroup 'testaccessrights'
de81b2e2 1756 testfilestats "$1" '%a' '=' "$2"
9beb11aa 1757 msggroup
de81b2e2 1758}
5684f71f 1759
0d58c26a 1760testwebserverlaststatuscode() {
1501a2c9 1761 msggroup 'testwebserverlaststatuscode'
0d58c26a 1762 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
03aa0847 1763 local STATUS='downloaded/webserverstatus-statusfile.log'
0d58c26a
DK
1764 rm -f "$DOWNLOG" "$STATUS"
1765 msgtest 'Test last status code from the webserver was' "$1"
6c0765c0 1766 if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
0d58c26a
DK
1767 msgpass
1768 else
68042532
DK
1769 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1770 {
1771 if [ -n "$2" ]; then
1772 shift
1773 echo >&2 '#### Additionally provided output files contain:'
1774 cat >&2 "$@"
1775 fi
1776 echo >&2 '#### Download log of the status code:'
1777 cat >&2 "$DOWNLOG"
1778 } >"$OUTPUT" 2>&1
1779 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
0d58c26a 1780 fi
9beb11aa 1781 msggroup
0d58c26a
DK
1782}
1783
785cb6fc
DK
1784createlistofkeys() {
1785 local OUTPUT="$1"
1786 shift
1787 while [ -n "$1" ]; do
eb5113c4
JAK
1788 # gpg 2.1.something starts printing [SC] at some point
1789 if grep -q ' rsa2048/' "$OUTPUT" && grep -qF '[SC]' "$OUTPUT"; then
1790 case "$1" in
1791 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1792 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [SC] [expired: 2013-07-13]';;
1793 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16 [SC]';;
1794 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19 [SC]';;
1795 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1796 *) echo 'UNKNOWN KEY';;
1797 esac
785cb6fc 1798 # gpg 2.1 has a slightly different output format
eb5113c4 1799 elif grep -q ' rsa2048/' "$OUTPUT"; then
785cb6fc
DK
1800 case "$1" in
1801 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1802 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1803 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16';;
1804 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19';;
1805 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1806 *) echo 'UNKNOWN KEY';;
1807 esac
1808 else
1809 case "$1" in
1810 *Joe*|*Sixpack*) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1811 *Rex*|*Expired*) echo 'pub 2048R/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1812 *Marvin*|*Paranoid*) echo 'pub 2048R/528144E2 2011-01-16';;
1813 oldarchive) echo 'pub 1024R/F68C85A3 2013-12-19';;
1814 newarchive) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1815 *) echo 'UNKNOWN KEY';;
1816 esac
1817 fi
1818 shift
1819 done
1820}
1821testaptkeys() {
1822 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output"
1823 if ! aptkey list | grep '^pub' > "$OUTPUT"; then
1824 echo -n > "$OUTPUT"
1825 fi
1826 testfileequal "$OUTPUT" "$(createlistofkeys "$OUTPUT" "$@")"
1827}
1828
89a1aa5d
DK
1829pause() {
1830 echo "STOPPED execution. Press enter to continue"
1831 local IGNORE
1832 read IGNORE
1833}
ab25bf1f 1834
846bc058 1835listcurrentlistsdirectory() {
ba6b79bd
DK
1836 {
1837 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1838 stat --format '%U:%G:%a:%n' "$line"
1839 done
1840 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1841 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1842 done
1843 } | sort
846bc058 1844}
912a6131
DK
1845forallsupportedcompressors() {
1846 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
0179cfa8 1847 if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi
912a6131
DK
1848 "$@" "$COMP"
1849 done
1850}
846bc058 1851
3a8776a3 1852### convenience hacks ###
8fe964f1
DK
1853mkdir() {
1854 # creating some directories by hand is a tedious task, so make it look simple
6aef1942
DK
1855 local PARAMS="$*"
1856 if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then
8fe964f1
DK
1857 # only the last directory created by mkdir is effected by the -m !
1858 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1859 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1860 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1861 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1862 if [ "$(id -u)" = '0' ]; then
1863 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1864 fi
1865 else
1866 command mkdir "$@"
1867 fi
1868}
1869
ab25bf1f
DK
1870### The following tests are run by most test methods automatically to check
1871### general things about commands executed without writing the test every time.
1872
1873aptautotest() {
1874 local TESTCALL="$1"
1875 local CMD="$2"
1876 local FIRSTOPT="$3"
896f0ae8 1877 local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d -c 'A-za-z0-9')"
ab25bf1f
DK
1878 if command -v $AUTOTEST >/dev/null; then
1879 shift 3
1880 # save and restore the *.output files from other tests
1881 # as we might otherwise override them in these automatic tests
63c71412
DK
1882 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1883 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1884 mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp"
ab25bf1f 1885 $AUTOTEST "$TESTCALL" "$@"
63c71412
DK
1886 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1887 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1888 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp"
ab25bf1f
DK
1889 fi
1890}
1891
1892aptautotest_aptget_update() {
59148d96
DK
1893 local TESTCALL="$1"
1894 while [ -n "$2" ]; do
1895 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1896 shift
1897 done
ab25bf1f 1898 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
4bb006d1
DK
1899 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1900 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
ab25bf1f 1901 # all copied files are properly chmodded
63c71412
DK
1902 local backupIFS="$IFS"
1903 IFS="$(printf "\n\b")"
146f7715 1904 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
4bb006d1 1905 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
ab25bf1f 1906 done
63c71412 1907 IFS="$backupIFS"
59148d96 1908 if [ "$TESTCALL" = 'testsuccess' ]; then
146f7715
DK
1909 # failure cases can retain partial files and such
1910 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1911 fi
ab25bf1f
DK
1912}
1913aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
d84da499 1914aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
016bea82
DK
1915
1916testaptautotestnodpkgwarning() {
1917 local TESTCALL="$1"
1918 while [ -n "$2" ]; do
6bf93605
DK
1919 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1920 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
016bea82
DK
1921 shift
1922 done
1923 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1924}
1925
1926aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1927aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1928aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1929aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1930aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1931aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }